#ifndef CTPUZZLE_NEIGHBOURHOOD__
#define CTPUZZLE_NEIGHBOURHOOD__
////////////////////////////////////////////////////////////////////////////////
#include "brick.h"
////////////////////////////////////////////////////////////////////////////////
struct Neighbourhood
{
    Neighbourhood() {}
    ~Neighbourhood() { clearMasks(); }
    void clearMasks();
    void newMasks(int n);
    void init(vector<BrickRot>& br,int NB0);
    void allCellNeighbours();
    void addCheckedNeighbour(int ic,int i,int j,int k);
    void initMasksLarge();
    int checkedIndex(int ifalse,int i,int j,int k) const;
    void setLarge(uint *p,int ic1,int in);
    void getNbUsage(vector<BrickRot>& br,int NB0);
    uint getLarge(uint *p,int ic) const;
    void reduce(int NB0);
    void initMasks();
    void set(uint *p,int ic1,int in);
    void brickNbMask(const Brick& b,uint *p) const;
    void brickNbMask(const Brick& b,uint *p,vector<uint>& v) const;
    uint get(uint *p,int ic) const;
    void findIndicees(uint m,uint m0,int bit,vector<uint>& v,int end) const;

    vector<uint*> cellNbMask;
    vector<int> value;
    vector<vector<int> > cellNb;
    vector<vector<Coord> > cellNbCoord;
};
////////////////////////////////////////////////////////////////////////////////
#endif
